/**
*	 "CBookItems"     
*	     ,    ,   
*	      ,   
*	       
*	     ,   
*	       
*	       
*/

#pragma once
#include <iostream>
#include <string>
#include <vector>
#include <fstream>

using namespace std;


class CBookItems
{
public:
  template<class T>
	class BookItem
	{
		private:
			T _sFirstName;
			T _sLastName;
			T _sPhoneNumber1;
			T _sPhoneNumber2;
		public:
			BookItem()
			{
			}
			virtual ~BookItem()
			{
			}

		//===============================================================================
		/**
		*  /
		*/
		friend std::ostream& operator<<(std::ostream& s, const BookItem<string>& item);
		friend std::istream& operator>>(std::istream& s, BookItem<string>& item);

		friend CBookItems;
	};

	vector<BookItem<string> > _aItems;

public:
	
	//===============================================================================
	/**
	*       
	*/
	void CreateNewItem(string sFirstName, string sLastName, string sPhoneNumber1);
	
	//===============================================================================
	/**
	*        (2 )
	*/
	void CreateNewItem(string sFirstName, string sLastName, string sPhoneNumber1, string sPhoneNumber2);

	//===============================================================================
	/**
	*     
	*/
	int SetNewValueToItem(string sFirstName, string sLastName, string sPhoneNumber1, int nNumOfItem);

	//===============================================================================
	/**
	*      (2 )
	*/
	int SetNewValueToItem(string sFirstName, string sLastName, string sPhoneNumber1, string sPhoneNumber2, int nNumOfItem);

	//===============================================================================
	/**
	*    
	*/
	int GetItem(int nNumOfItem, string& sFirstName, string& sLastName, string& sPhoneNumber1);

	//===============================================================================
	/**
	*     (2 )
	*/
	int GetItem(int nNumOfItem, string& sFirstName, string& sLastName, string& sPhoneNumber1, string& sPhoneNumber2);

	//===============================================================================
	/**
	*   
	*/
	const BookItem<string>& GetItem(int nNumOfItem);

	//===============================================================================
	/**
	*     
	*/
	int GetSize();

	//===============================================================================
	/**
	*       
	*/
	int SortItems(int nSortingType);

	//===============================================================================
	/**
	*   ,     
	*/
	int FindItem(string sDesiredValue, int nSortingType, vector<int>& nNumOfDesirvedItems);

	//===============================================================================
	/**
	*    
	*/
	int SaveItems(string sNameOfFile);

	//===============================================================================
	/**
	*    
	*/
	int LoadItems(string sNameOfFile);
};